/****************************************************************************
* e2Ligth4 - Light Control  for Rokr E2
*
* Autor: Carlos Aguilar aka "Kidscracker" kidscracker@gmail.com
*
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
#ifndef __ZGUI_H
#define __ZGUI_H
/*
#define QT_NO_DRAGANDDROP
#define QT_NO_PROPERTIES
*/
#ifdef EZX_H
	#include <E2_EZX_ZApplication.h>
	#include <E2_EZX_ZWidget.h>
	#include <E2_EZX_ZKbMainWidget.h>
	#include <E2_EZX_ZLabel.h>
	#include <E2_EZX_ZComboBox.h>
	#include <E2_EZX_ZSoftKey.h>
	#include <E2_EZX_ZMessageDlg.h>
	#include <E2_EZX_ZSingleSelectDlg.h>
	#include <E2_EZX_ZNumPickerDlg.h>

	#include <E2_EZX_ZScrollPanel.h>
	#include <E2_EZX_ZScrollView.h>
	#include <E2_EZX_ZListBox.h>
	#include <E2_EZX_ZNoticeDlg.h>

	#include <E2_EZX_ZNavTabWidget.h>
	
	#include <E2_EZX_ZProgressDlg.h>
	
#else
	#include <ZApplication.h>
	#include <ZWidget.h>
	#include <ZKbMainWidget.h>
	#include <ZLabel.h>
	#include <ZComboBox.h>
	#include <ZSoftKey.h>
	#include <ZMessageDlg.h>
	#include <ZSingleSelectDlg.h>
	#include <ZNumPickerDlg.h>

	#include <ZScrollPanel.h>
	#include <ZScrollView.h>
	#include <ZListBox.h>
	#include <ZNoticeDlg.h>
	
	#include <ZNavTabWidget.h>

	#include <ZProgressDlg.h>
	
	#include <ZOptionsMenu.h>

	#include <ZMainWidget.h>
#endif	

#include <qlayout.h>
#include <qtimer.h>
#include <qpainter.h>
#include <qpixmap.h>

#include <qstringlist.h>

#include <qdir.h>
#include <qdict.h>

#include <libgen.h>

#include <iostream>

#include <QString.h>
#include <qtextcodec.h>

#include <qobjectlist.h>

#include <ZKeyDef.h>

//#include "ConfigFile.h"
#include "LanguageConfig.h"

class zLanguage_Panel;
class zLights_Panel;
class zBT_Panel;
class zSound_Panel;
class zSDManager_Panel;

class ZGui : public ZKbMainWidget
{
	Q_OBJECT
public:
    ZGui (QWidget* parent = 0, const char* name = 0, QDir homePath = QDir("./"), WFlags fl = 0 );
    ~ZGui();

    void CreateControls(QWidget* parent);
	void LoadConfigs();
	
    QString getAppPath();
	QDir getAppDir();
	void refreshControlsLanguage();
	bool AutodetecLanguage(const QString& );
	void Fill_LanguageListBox();
	bool GetFileList(QDir &dir, QStringList & fl);
	void updateControlValues(bool force);
	void setAppDir(QDir dr);
	
	ZSoftKey* getSoftKey();
	ZOptionsMenu* getmnMainMenu();
	ZOptionsMenu* getmnOtherOptions();
	ZOptionsMenu* getmnResetCodes();
	
protected:
	void keyPressEvent(QKeyEvent* event);

public slots:
	virtual void timerEvent(QTimerEvent* e);
	

	void tab1Activated (int index );
	void pageChanged(QWidget* w);

	
    void slotLanguageListSelected(int);	
	void slotOptionChange(int);
	void slotMenu();
    void slotAbout();
	
	void quit();

	void slotProgressDlgCancelled();
	void slotProgressDlgTimer();
	
	void slotResetSecuritySecurityCode();
	void slotResetSecurityUnlockCode();

	void slotRestartPhone();
private:
	zLights_Panel* getLightsTab();
	zLanguage_Panel* getLanguageTab();
	zBT_Panel* getBTTab();
	zSound_Panel* getSoundTab();
	zSDManager_Panel* getSDManagerTab();

	zLights_Panel* tabLights;
	zLanguage_Panel* tabLanguage;
	zBT_Panel* tabBT;
	zSound_Panel* tabSound;
	zSDManager_Panel* tabSDManager;
	
	ZNavTabWidget* tabWidget;

	ZSoftKey* SoftKey;
	ZOptionsMenu* mnMainMenu;
	ZOptionsMenu* mnOtherOptions;
	ZOptionsMenu* mnResetCodes;

	QDir Home_Dir;
    QString Home_Path;
    ZScrollPanel *scrollPanel;

	QStringList slListFiles;
	
	
	int currentOption;
	int currentLangSelect;

	ZProgressDlg *pdlg;
};

#endif
