/****************************************************************************
* e2Ligth4 - Light Control  for Rokr E2
*
* Autor: Carlos Aguilar aka "Kidscracker" kidscracker@gmail.com
*
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
//#define EZX_H

#include "zLanguage_Panel.h"
#include "ZGui.h"

using namespace std;
extern LanguageConfig *lng;

zLanguage_Panel::zLanguage_Panel ( ZGui * _parent) : 
	zBase_Panel ( (QWidget*)_parent, "tabPage_Language" )
{
	// Set parent QWidget (ZGui in this case)
	parent = _parent;

	lblIdioma = NULL;
	lstIdioma = NULL;
	
	// Set ContentWidget
	setContentWidget( getSPanel() );

	connect( getlstIdioma() , SIGNAL( selected (int) ), this, SLOT( slotLanguageListSelected(int) ) );

	ZScrollPanel* lstSPanel = new ZScrollPanel(this, "ZScrollPanel_LanguageList", 0, (ZSkinService::WidgetClsID)4);
		lstSPanel->resize(240,194);
		lstSPanel->addChild(getlstIdioma(), 0, 0);

	tabSPanel->addChild( getlblIdioma() , 5, 5);
	tabSPanel->addChild( lstSPanel , 0, 35);
	return;
}

zLanguage_Panel::~zLanguage_Panel()
{
//	cout<<"zLanguage_Panel::~zLanguage_Panel - Entry"<<endl;
	delete lstIdioma;
	delete lblIdioma;
	delete tabSPanel;
//	cout<<"zLanguage_Panel::~zLanguage_Panel - Exit"<<endl;
}

ZGui* zLanguage_Panel::getParent()
{
	return parent;
}

void zLanguage_Panel::slotLanguageChanged(bool fRedraw)
{	
	getlblIdioma()->setText(lng->getText("LANGUAGE_FILES"));
}

/*
	SINGLETON PART
*/

ZLabel* zLanguage_Panel::getlblIdioma()
{
	if (lblIdioma!=NULL)
		return lblIdioma;
	
	lblIdioma = new ZLabel( "", parent, "lblIdioma", 0, (ZSkinService::WidgetClsID)4);
		lblIdioma->setFixedWidth(240);
		lblIdioma->setAutoResize(true);
		
	return lblIdioma;
}

ZListBox* zLanguage_Panel::getlstIdioma()
{
	if (lstIdioma!=NULL)
		return lstIdioma;

	lstIdioma = new ZListBox ( QString ( "%M" ), parent, 0, (ZSkinService::WidgetClsID)4);
		lstIdioma->setFixedWidth ( 240 );

	return lstIdioma;
}

ZScrollPanel* zLanguage_Panel::getSPanel()
{
	if (tabSPanel!=NULL)
		return tabSPanel;
		
	tabSPanel = new ZScrollPanel(this, "ZScrollPanel_Language", 0, (ZSkinService::WidgetClsID)4);
		tabSPanel->resize(240,100);
	return tabSPanel;
}

/*
	SLOTS
*/
void zLanguage_Panel::slotLanguageListSelected ( int index ) 
{
	( (ZGui*)parent )->slotLanguageListSelected(index);
}
