/****************************************************************************
* e2Ligth4 - Light Control  for Rokr E2
*
* Autor: Carlos Aguilar aka "Kidscracker" kidscracker@gmail.com
*
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
//#define EZX_H

#include "zLights_Panel.h"
#include "ZGui.h"

using namespace std;
extern LanguageConfig *lng;

zLights_Panel::zLights_Panel ( ZGui * _parent) : 
	zBase_Panel ( _parent, "tabPage_Lights")
{

	lblOpcion = NULL;
	cbOpcion = NULL;
	lblValorOpcion = NULL;

	nmValorOpcion = NULL;
	lblValorUnidad = NULL;


	// Set parent QWidget (ZGui in this case)
	parent = _parent;

	// Set ContentWidget
	setContentWidget( getSPanel() );

/*	
	QPalette pal=sv->palette();
	QColorGroup cg=pal.active();
	cg.setColor(QColorGroup::Base,Qt::gray);
	pal.setActive(cg);
	sv->setPalette(pal);
*/
	tabSPanel->addChild( getlblOpcion(), 0, 10);
	tabSPanel->addChild( getcbOpcion(), 5, 40);
	tabSPanel->addChild( getlblValorOpcion() ,0, 110);
	tabSPanel->addChild( getnmValorOpcion() ,80, 90);
	
	return;
}

zLights_Panel::~zLights_Panel()
{
//	cout<<"zLights_Panel::~zLights_Panel - Entry"<<endl;
	delete lblOpcion;
	delete cbOpcion;
	delete lblValorOpcion;
	delete nmValorOpcion;
	delete tabSPanel;
//	cout<<"zLights_Panel::~zLights_Panel - Exit"<<endl;
}

ZGui* zLights_Panel::getParent()
{
	return parent;
}

void zLights_Panel::slotLanguageChanged(bool fRedraw)
{
	int tmp;
	ZComboBox* cbOpcion;
	
	getlblOpcion()->setText(lng->getText("TIME_TO_MODIFY"));

	tmp = getcbOpcion()->currentItem();

	cbOpcion = getcbOpcion();
	cbOpcion->clear();
		cbOpcion->insertItem(lng->getText("SCREENSAVER_TIMEOUT"),0);
		cbOpcion->insertItem(lng->getText("DISPLAY_TIMEOUT"), 1);
		cbOpcion->insertItem(lng->getText("BACKLIGHT_TIMEOUT"), 2);
		cbOpcion->insertItem(lng->getText("KEYPAD_BACKLIGHT"), 3);

	cbOpcion->setCurrentItem(tmp);

	getlblValorOpcion()->setText(lng->getText("VALUE"));
	getlblValorUnidad()->setText(lng->getText("SECONDS"));
}

/*
	SINGLETON PART
*/

ZLabel* zLights_Panel::getlblOpcion()
{
	if (lblOpcion!=NULL)
		return lblOpcion;
	
	lblOpcion = new ZLabel( "", parent, "lblIdioma", 0, (ZSkinService::WidgetClsID)4);
		lblOpcion->setFixedWidth(240);
		lblOpcion->setAutoResize(true);
		lblOpcion->setAlignment( (ZLabel::AlignmentFlags) (Qt::AlignVCenter | Qt::AlignCenter ) );

	return lblOpcion;
}

ZComboBox* zLights_Panel::getcbOpcion()
{
	if (cbOpcion!=NULL)
		return cbOpcion;
		
	cbOpcion = new ZComboBox(parent,"cbOpcion",true);
	cbOpcion->setFixedWidth(220);
		cbOpcion->insertItem("", 0);
		cbOpcion->insertItem("", 1);
		cbOpcion->insertItem("", 2);
		cbOpcion->insertItem("", 3);
	
	cbOpcion->setCurrentItem(0);

	return cbOpcion;
}

ZLabel* zLights_Panel::getlblValorOpcion()
{
	if (lblValorOpcion!=NULL)
		return lblValorOpcion;

	lblValorOpcion = new ZLabel( "", parent, "lblValorOpcion", 0, (ZSkinService::WidgetClsID)4);
		lblValorOpcion->setFixedWidth(80);
		lblOpcion->setAutoResize(true);
		lblValorOpcion->setAlignment( (ZLabel::AlignmentFlags) (Qt::AlignVCenter | Qt::AlignCenter ) );

	return lblValorOpcion;
}

ZNumModule* zLights_Panel::getnmValorOpcion()
{
	if (nmValorOpcion!=NULL)
		return nmValorOpcion;
		
	// NumPicker for the value of the option
	nmValorOpcion = new ZNumModule(3, parent, "nmValorOpcion", 0, (ZSkinService::WidgetClsID)4);
		nmValorOpcion->setFixedWidth(160);
		nmValorOpcion->setFixedHeight(80);

		// To avoid the annoying comportament while it has the focus and change it's value insteand of going to the previous Control
		nmValorOpcion->setFocusProxy(parent);

		nmValorOpcion->setLabel( getlblValorUnidad(), (ZNumModule::RelativeAlignment)1); 

	return nmValorOpcion;
}

ZLabel* zLights_Panel::getlblValorUnidad()
{
	if (lblValorUnidad!=NULL)
		return lblValorUnidad;

	// Label for indicating the units (seconds)
	lblValorUnidad = new ZLabel("",nmValorOpcion,"lblValorUnidad", 0, (ZSkinService::WidgetClsID) 4);
	
	return lblValorUnidad;
}

ZScrollPanel* zLights_Panel::getSPanel()
{
	if (tabSPanel!=NULL)
		return tabSPanel;

	tabSPanel = new ZScrollPanel(this, "ZScrollPanel_Lights", 0, (ZSkinService::WidgetClsID)4);
	
	return tabSPanel;
}

/*
	SLOTS
*/
