/****************************************************************************
* e2Ligth4 - Light Control  for Rokr E2
*
* Autor: Carlos Aguilar aka "Kidscracker" kidscracker@gmail.com
*
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
//#define EZX_H

#include "ZGui.h"
#include "zSDManager_Panel.h"

extern ZConfig *ezx_system;
extern LanguageConfig *lng;

using namespace std;

zSDManager_Panel::zSDManager_Panel ( ZGui * _parent) : 
	zBase_Panel( _parent, "tabPage_SDManager")
{
	// Set parent QWidget (ZGui in this case)
	parent = _parent;

	//btnSD = NULL;

	setContentWidget( getSPanel() );

	return;
}

zSDManager_Panel::~zSDManager_Panel()
{
	killTimers();
}

ZGui* zSDManager_Panel::getParent()
{
	return parent;
}

void zSDManager_Panel::slotLanguageChanged(bool fRedraw)
{
	if (tabSPanel)
	{
/*
		getlblVolModTitle()->setText( lng->getText("SND_VOL_MOD_TITLE") );
		getlblFrecuencia()->setText( lng->getText("SND_FREQUENCY") );
		
		getlblFrecVolume()->setText( GainMessage->arg( (*ptrVolumeTable)[lastOption].values[lastFrecuency] ) );
*/
	}
}

void zSDManager_Panel::DetectMounted()
{
	struct mntent *mnt;
	FILE *fp;
	char *devopt;

	fp = setmntent (MOUNTED, "r");
	if (fp == NULL)
	    return;

		
    ZScrollView* sv = new ZScrollView( this, "ZScrollView", 0) ;
    QVBox* big_box = new QVBox(sv->viewport());
    sv->addChild(big_box);
		sv->resize(240,215);
		
	ZPressButton* pbSD;
	QPixmap *qp = new QPixmap();
	QLabel *lblSD;
	int top = 20;
	while ((mnt = getmntent (fp))) {
	
		pbSD = new ZPressButton( "", this, "ZPressButton_pbSD");
			pbSD->setAutoResize(false);
			pbSD->resize(60,60);

		if ( strstr(mnt->mnt_fsname,"/dev/mmc")!=NULL)
			qp->load( parent->getAppDir().absFilePath("img/sandisk.png") );
		else
			qp->load( parent->getAppDir().absFilePath("img/chip.png") );
			
			pbSD->setPixmap( QPixmap(*qp) );
		
		sv->addChild( pbSD, 0, top);

		lblSD = new  QLabel("<qt><font size=\"-1\">" + QString(mnt->mnt_fsname) + "</font></br>"
							"<font size=\"-2\">"+ QString(mnt->mnt_dir) + " <b>(" + QString(mnt->mnt_type) + ")</b></font></br></qt>", sv);
		lblSD->setAutoResize(true);
		
		sv->addChild( lblSD, 65, top);
	
		connect( pbSD, SIGNAL( selectionStateChanged (const SelectionState) ), this, SLOT( slotClickedIcon(const SelectionState) ) );
	
		top+=65;
	}
	endmntent(fp);
}


/*
	SINGLETON PART
*/
ZScrollPanel* zSDManager_Panel::getSPanel()
{
	if (tabSPanel!=NULL)
		return tabSPanel;
		
	tabSPanel = new ZScrollPanel(this, "ZScrollPanel_SDMAnager", 0, (ZSkinService::WidgetClsID)4);

	DetectMounted();

	return tabSPanel;
}


/*
	SLOTS
*/
void zSDManager_Panel::timerEvent(QTimerEvent* e)
{
}

void zSDManager_Panel::slotClickedIcon(const ZPressButton::SelectionState state)
{
	if (state == StHighlightSelected)
	{
		cout<<"Current Widget : "<<qApp->focusWidget()<<endl;
	}
}
