/****************************************************************************
* e2Ligth4 - Light Control  for Rokr E2
*
* Autor: Carlos Aguilar aka "Kidscracker" kidscracker@gmail.com
*
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
#ifndef __ZSOUND_PANEL_H
#define __ZSOUND_PANEL_H
/*
#define QT_NO_DRAGANDDROP
#define QT_NO_PROPERTIES
*/
#ifdef EZX_H
	#include <E2_EZX_ZWidget.h>
	#include <E2_EZX_ZKbMainWidget.h>	
	#include <E2_EZX_ZMainWidget.h>
	#include <E2_EZX_ZLabel.h>
	#include <E2_EZX_ZComboBox.h>
	#include <E2_EZX_ZSoftKey.h>
	#include <E2_EZX_ZMessageDlg.h>
	#include <E2_EZX_ZSingleSelectDlg.h>
	#include <E2_EZX_ZNumPickerDlg.h>

	#include <E2_EZX_ZScrollPanel.h>
	#include <E2_EZX_ZScrollView.h>
	#include <E2_EZX_ZListBox.h>
	#include <E2_EZX_ZNoticeDlg.h>
	
	#include <E2_EZX_ZSliderModule.h>
	
	#include <E2_EZX_ZPressButton.h>
//	#include <E2_EZX_ZImageContainer.h>
	
#else
	#include <ZWidget.h>
	#include <ZMainWidget.h>
	#include <ZLabel.h>
	#include <ZComboBox.h>
	#include <ZSoftKey.h>
	#include <ZMessageDlg.h>
	#include <ZSingleSelectDlg.h>
	#include <ZNumPickerDlg.h>

	#include <ZScrollPanel.h>
	#include <ZScrollView.h>
	#include <ZListBox.h>
	#include <ZNoticeDlg.h>

	#include <ZSliderModule.h>
	
	#include <ZPressButton.h>
//	#include <ZImageContainer.h>
#endif	

#include <qpainter.h>
#include <qwidget.h>

#include "zBase_Panel.h"

#include <qlayout.h>

#include <qvbox.h>

#include <qfile.h>
#include <qtextstream.h>
#include <qstringlist.h>

#include <iostream>

class ZGui;
struct VolumeTable_Entry{
	QString* Name;
	int values[10];
};

typedef QValueList<VolumeTable_Entry> VolumeTable_EntryList;

struct GEQ_ViewPrivate; 

class Q_EXPORT GEQ_View : public ZWidget
{
    Q_OBJECT
	char tmp[128];
public:
    GEQ_View(QWidget * parent,const char * name = 0, WFlags f  = 0,const ZSkinService::WidgetClsID clsId = (ZSkinService::WidgetClsID)0);

    GEQ_View(QPixmap & pixmap, QWidget * parent,const char * name = 0, WFlags f  = 0,const ZSkinService::WidgetClsID clsId = (ZSkinService::WidgetClsID)0);
    ~GEQ_View();
    QPixmap * pixmap() const {return lpixmap;}
   
    void      setPixmap(const QPixmap & pixmap);
    QSize sizeHint() const ;

	void setVolumeTableList(VolumeTable_EntryList* ptrVolumeTable = NULL);
	void setCurrentTable(int index = 0);

private:
    void init(const ZSkinService::WidgetClsID clsId);
    void clearContents();
    QRect getContentRect();

protected:
    void paintEvent(QPaintEvent * );
    virtual void setPalette(const QPalette &);
private:
	VolumeTable_EntryList* ptrCurrentVolumeTable;
	int indexCurrentVolumeTableIndex;
	
    QPixmap *lpixmap;

};

class zSound_Panel : public zBase_Panel
{
	Q_OBJECT
public:
    zSound_Panel (ZGui* parent);
    ~zSound_Panel();
	ZGui* getParent();
	ZScrollPanel* getSPanel();

	void LoadVolumeTable();
	void SaveVolumeTable(QString);
/*
	ZLabel* getlblTiempoAlarma();
	ZNumModule* getnmTiempoAlarma();
	ZLabel* getlblTiempoUnidad();
*/
	ZScrollPanel* getVolModSPanel();
	ZLabel* getlblVolModTitle();
	ZComboBox* getcbOpcion();
	ZLabel* getlblFrecuencia();
	ZComboBox* getcbFrecuencia();
	ZLabel* getlblFrecVolume();
	ZSliderModule* getslmVolValue();
	GEQ_View* getgeqView();
	
	virtual void slotLanguageChanged(bool fRedraw);

public slots:
	void timerEvent(QTimerEvent* e);

	void slotValueChanged(int value);

	void slotOpcionActivated(int index);
	void slotFrecuenciaActivated(int index);

private:
	VolumeTable_EntryList* ptrVolumeTable;
	
/*
	ZNumModule* nmTiempoAlarma;
	ZLabel* lblTiempoAlarma;
	ZLabel* lblTiempoUnidad;
*/
//	VolTable Mod
	ZScrollPanel* tabVolModSPanel;
	ZLabel* lblVolModTitle;
	ZComboBox* cbOpcion;
	ZLabel* lblFrecuencia;
	ZComboBox* cbFrecuencia;
	ZLabel* lblFrecVolume;
	ZSliderModule* slmVolValue;
	QString* GainMessage;

	GEQ_View* geqView;
	
	int lastOption;
	int lastFrecuency;
	
};

#endif
